package cn.rankin.productservice.controller;

import cn.rankin.common.utils.enums.BaseStatusEnum;
import cn.rankin.data.api.product.entity.Poster;
import cn.rankin.productservice.repository.PosterRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping(value = "/merchant")
@Slf4j
public class MerchantController {

    @Autowired
    private PosterRepository posterRepo;

    @RequestMapping(value = "/{merchantId}/posters", method = RequestMethod.GET)
    public List<Poster> getPosters(@PathVariable("merchantId") String merchantId, @RequestParam("start") Long start,
                                         @RequestParam("offset") Integer offset, @RequestParam("sortKey") String sortKey,
                                         @RequestParam("direction") Sort.Direction direction) {

        //get posters
        Poster findSample = new Poster();
        findSample.setMerchantId(merchantId);
        findSample.setStatus(BaseStatusEnum.NORMAL);

        List<Poster> posters = posterRepo.find(findSample, start, offset, new Sort(direction, sortKey));

        if (null == posters){
            posters = new ArrayList<Poster>();
        }
        log.info("Find Posters, len={}", posters.size());
        return posters;
    }
}

